/*----------------------------------------------*/
/*						*/
/*		CLEANUP.C			*/
/*						*/
/* This file contains procedures to clean up the*/
/* global variables for the next menu cycle	*/
/*						*/
/*----------------------------------------------*/

/* top level */

void cleanup()
{
 deletecaseptrlist(caseptrroot);
 caseptrroot = NULL;
 deletecase(usercase);
 usercase = NULL;
 foundcase = NULL;	/* this one's only a pointer */
 deletecase(repcase);
 repcase = NULL;
 resetweights();	/* set back original weight values */
 fp = stdout;
}


/* delete a case pointer list */

void deletecaseptrlist(caseptrlist)
struct caseptrnode *caseptrlist;
{
 if (caseptrlist == NULL)
   {
    return;
   }
 else
   {
    deletecaseptrlist(caseptrlist->caseptrlink);
    free(caseptrlist);
   }
}


/* delete a case not in a case list */

void deletecase(caseptr)
struct casenode *caseptr;
{
 if (caseptr == NULL)
   {
    fprintf(stderr,"Huh? - case is NULL!\n");
    exit(1);
   }

 deletefieldlist(caseptr->fieldhead);	/* delete the fields */
 deletefieldlist(caseptr->solnhead);
 /* local repair rules not deleted */
 free(caseptr);
}


/* delete a list of fields */

void deletefieldlist(fieldlist)
struct fieldnode *fieldlist;
{
 if (fieldlist == NULL)
   {
    return;
   }
 else
   {
    deletefieldlist(fieldlist->fieldlink);
    if (fieldlist->fieldtype == STRTYPE ||
        fieldlist->fieldtype == ENUMTYPE)
      {
       free(fieldlist->strcontents);	/* erase string node */
      }
    else if (fieldlist->fieldtype == LISTTYPE)
      {
       deletelist(fieldlist->listcontents);
      }
    free(fieldlist);
   }
}


/* set weights back to original values */

void resetweights()
{
struct typenode *pointer;

 pointer = probdefnroot;

 while (pointer != NULL)
   {
    pointer->weight = pointer->oldweight;
    pointer = pointer->typelink;
   }
}

